<template>
  <div class="container mx-auto max-w-4xl">
    <headerr>
      <div class="font-lobster text-xl text-gray-700">
        Here is what you want to do today.
      </div>
      <template v-slot:right>
        <loader-vue v-if="loader.loadingLong" :thickness="4" color="blue" class="h-6 w-6" />
      </template>
    </headerr>

    <div v-if="grouped_tasks.length < 1">
      <div v-if="neverUsed" class="flex flex-col items-center text-center px-8 py-16">
        <img :src="RunnerStart" alt="" style="height: 20rem" class="px-8" />
        <div class="mt-16 font-bold px-">Your Focus View.</div>
        <div class="mt-2 text-gray-700 text-sm">
          Visit one of your workspaces and click the <i class="hero fire solid"></i> icon on a task to add it to this
          view!
        </div>
      </div>
      <div v-else class="flex flex-col items-center p-16 text-center">
        <img :src="RunnerStart" alt="" style="height: 20rem" />
        <div class="mt-16 font-bold">No Tasks for today.</div>
        <div class="mt-2 text-gray-700 text-sm">Go and choose something you want to get done today!</div>
      </div>
    </div>

    <div class="mb-64 container mx-auto flex flex-col items-stretch justify-start">
      <div v-for="[workspace, tasks] of grouped_tasks" :key="workspace.id || 'inbox'" :class="`mt-8 overflow-hidden`">
        <div @click="openWorkspace(workspace)" :class="`px-4 py-3 flex flex-col items-center`">
          <workspaces-indicator :value="workspace" />
        </div>
        <div class="-mt-px pb-2">
          <tasks-list
            sort="status"
            :tasks="tasks"
            class="mx-2 mt-1"
            :thin="responsive.width < responsive.breakpoints.sm"
            show-status
            hide-focus
          />
        </div>
      </div>
    </div>
  </div>
</template>

<script lang="ts">
import TasksList from "@/components/Tasks/List.vue";
import WorkspacesIndicator from "@/components/Workspaces/Indicator.vue";
import Task from "@/models/Task";
import Workspace from "@/models/Workspace";
import { computed } from "vue";
import responsive from "@/use/responsive";
import Responsive from "@/components/Responsive";
import { asyncCache, cache } from "@/use/cache";
import { DateTime } from "luxon";
import LoaderVue from "@/components/Loader.vue";
import { Loader } from "@/use/Loader";
import { openWorkspace } from "@/use/navigation";
import { watchedRef } from "@/use/watchedRef";
import RunnerStart from "@/assets/img/undraw_add_notes.svg";

export default {
  components: {
    TasksList,
    WorkspacesIndicator,
    Responsive,
    LoaderVue
  },
  setup() {
    const loader = new Loader();

    const query = Task.query()
      .apply("undone", DateTime.now().startOf("day"))
      .andWhere("todayAt", "<", DateTime.now());

    cache.get("focus", () => loader.load(query.get()));

    return {
      RunnerStart,
      loader,
      responsive,
      openWorkspace,
      neverUsed: watchedRef(() =>
        asyncCache.make("neverUsed", () => {
          return Task.query()
            .whereNot("todayAt", null)
            .first()
            .then(first => first == undefined);
        })
      ),
      grouped_tasks: computed(() =>
        [Workspace.inbox, ...Workspace.allSync()]
          .map(
            workspace =>
              [
                workspace,
                (workspace
                  .tasks()
                  .query()
                  .where(() => query) as any).getSync()
              ] as [Workspace, Task[]]
          )
          .filter(([_, tasks]) => tasks.length > 0)
      )
    };
  }
};
</script>
